package com.memorynotfound;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import javax.faces.application.ApplicationConfigurationPopulator;
import java.io.FileOutputStream;
import java.io.IOException;

public class FacesConfig extends ApplicationConfigurationPopulator {

    @Override
    public void populateApplicationConfiguration(Document fcDoc) {
        String ns = fcDoc.getDocumentElement().getNamespaceURI();
        Element lifecycleEl = fcDoc.createElementNS(ns, "lifecycle");
        Element phaselistenerEl = fcDoc.createElementNS(ns, "phase-listener");
        phaselistenerEl.appendChild(fcDoc.createTextNode("com.memorynotfound.DebugPhaseListener"));
        lifecycleEl.appendChild(phaselistenerEl);
        fcDoc.getDocumentElement().appendChild(lifecycleEl);
        try {
            serializeFacesConfig(fcDoc, "faces-config.xml");
        } catch (IOException e) {
            System.err.println("could not create faces-config");
        }
    }

    private void serializeFacesConfig(Document document, String path) throws IOException {
        FileOutputStream fos = null;
        OutputFormat outFormat = new OutputFormat();
        outFormat.setIndent(5);
        outFormat.setLineWidth(150);

        fos = new FileOutputStream(path);

        XMLSerializer xmlSerializer = new XMLSerializer();
        xmlSerializer.setOutputFormat(outFormat);
        xmlSerializer.setOutputByteStream(fos);

        xmlSerializer.serialize(document);
    }
}
